""" Addon Information """
# ------------
# EventScripts Script-Addon:    - BackRaw's SeekMe (SeekMe, seekme.py, 3.9kb)
# Author:                       - BackRaw - http://forums.eventscripts.com/profile.php?mode=viewprofile&u=13683
#                                           http://addons.eventscripts.com/addons/user/13683
# Version:                      - 1.0
# ------------

""" Imports """
# ------------
# EventScripts Core-Module            - ES functionality
import es
# Popuplib                            - Popup menus
import popuplib
# Gamethread                          - Delayed functions
import gamethread
# Path (OS)                           - Check file existens
from os.path import isfile
# Random                              - Get random values
from random import choice as rChoice
# Playerlib                           - Change player-models
from playerlib import getPlayer
# ConfigObj (configobj)               - Configuration files
from configobj import ConfigObj
# ------------

""" Global Variables """
# ------------
# This player-dictionary will hold everyone's models, paths, model-names, and perspectives
player = {}
# We need the addon's path more than once...
addonPath = es.getAddonPath('seekme')
# ------------

""" Public Functions """
# ------------
# This model-handler will return either a model-list, current model-name or the config file, or will add options to the popup
# ------------
def models(add=False, popup=False):
    path = addonPath + '/models/%s.ini' % es.getString('eventscripts_currentmap')
    if isfile(path):
        cfg = ConfigObj(path)
        if add:
            if type(add) == bool:
                if popup:
                    for model in cfg:
                        obj = cfg[model]
                        name = obj['name']
                        st = ('an' if name[0].lower() in ['a', 'e', 'i', 'o', 'u'] else 'a')
                        if name == 'Toilet Roll':
                            st = 'some'
                        popup.addoption(obj['path'], '%s %s' % (st, name))
                    return 0
                else:
                    ml = []
                    for model in cfg:
                        ml.append(cfg[model]['path'])
                    return ml
            else:
                curname = 0
                for model in cfg:
                    if cfg[model]['path'] == add:
                        curname = cfg[model]['name']
                        break
                return curname
        return cfg
    return None

# ------------
# This config-wrapper will return Integers from the configuration file "seekme_config.ini" in the addon's folder
# ------------
def config(option):
    return int(ConfigObj(addonPath + '/seekme_config.ini')[option])

""" Class - Player """
# ------------
# This class handles all the player-specific stuff
# ------------
class Player(object):
    def __init__(self, userid):
        self.userid = userid
        self.path = self.name = self.tp = self.used = 0
    def strip(self):
        es.server.queuecmd('es_xfire %s player_weaponstrip kill' % self.userid)
        es.server.queuecmd('es_xgive %s player_weaponstrip' % self.userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip' % self.userid)
        es.server.queuecmd('es_xgive %s item_assaultsuit' % self.userid)
    def spawn(self, team):
        if models() is not None:
            self.used = 0
            if team == 2:
                _player = getPlayer(self.userid)
                self.strip()
                if es.getplayersteamid(self.userid) == 'BOT':
                    _player.set('model', rChoice(models(True)))
                else:
                    if self.path:
                        _player.set('model', self.path)
                        es.tell(self.userid, '#multi', '#green[#lightgreenSeekMe#green] #defaultYour current model: #green%s' % self.name)
                    else:
                        es.tell(self.userid, '#multi', '#green[#lightgreenSeekMe#green] #defaultYou can use #green!hide #defaultto change your model to hide.')
            elif team == 3:
                what = config('type')
                time = config('time')
                if what == 1:
                    es.setplayerprop(self.userid, 'CBaseEntity.movetype', 0)
                    gamethread.delayedname(time, 'unfreeze_%s' % self.userid, es.setplayerprop, (self.userid, 'CBaseEntity.movetype', 2))
                elif what == 2:
                    f = {'CCSPlayer.m_flFlashMaxAlpha':255, 'CCSPlayer.m_flFlashDuration':time}
                    for x in f:
                        es.setplayerprop(self.userid, x, 0)
                    for x in f:
                        es.setplayerprop(self.userid, x, f[x])
                gamethread.delayedname(time, 'announce_%s' % self.userid, es.tell, (self.userid, '#multi', '#green[#lightgreenSeekMe#green] #defaultYou have to search and some hiders...'))
    def changeModel(self, choice):
        curname = models(choice)
        self.path = choice
        self.name = curname
        self.used = 1
        self.strip()
        getPlayer(self.userid).set('model', choice)
        es.tell(self.userid, '#multi', '#green[#lightgreenSeekMe#green] #defaultYour current model: #green%s' % curname)
    def perspective(self):
        es.setplayerprop(self.userid, 'CBasePlayer.m_hObserverTarget', 0)
        if self.tp:
            om = 0
            dv = 1
            fov = 90
            self.tp = 0
        else:
            om = 1
            dv = 0
            fov = 120
            self.tp = 1
        es.setplayerprop(self.userid, 'CBasePlayer.m_iObserverMode', om)
        es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_Local.m_bDrawViewmodel', dv)
        es.setplayerprop(self.userid, 'CBasePlayer.m_iFOV', fov)
    def hide(self):
        if es.getplayerteam(self.userid) == 2:
            if not es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
                if not self.used:
                    name = 'seekme_popup'
                    curmap = es.getString('eventscripts_currentmap')
                    if popuplib.exists(name):
                        popuplib.delete(name)
                    if models() is not None:
                        menu = popuplib.easymenu(name, '_popup_choice', menuSelect)
                        menu.settitle('Choose model for %s' % curmap)
                        models(True, menu)
                        menu.send(self.userid)
                    else:
                        es.tell(self.userid, '#multi', "#green[#lightgreenSeekMe#green] #defaultMap #green%s #defaultisn't available yet." % curmap)
                else:
                    es.tell(self.userid, '#multi', '#green[#lightgreenSeekMe#green] #defaultYou can only use #green!hide #defaultonce a round!')
            else:
                es.tell(self.userid, '#multi', '#green[#lightgreenSeekMe#green] #defaultOnly alive Terrorists can change their models!')
        else:
            es.tell(self.userid, '#multi', "#green[#lightgreenSeekMe#green] #default%ss can't change their models!" % ('CT' if team == 3 else 'Spectator'))

""" Events """
# ------------
# Add the connecting player to the database
# ------------
def player_activate(ev):
    userid = ev['userid']
    player[userid] = Player(userid)

# ------------
# Strip the player off his/her weapons and change the model if he/she's T, else freeze/blind him/her for a few seconds before the game actually starts
# ------------
def player_spawn(ev):
    userid = ev['userid']
    team = int(ev['es_userteam'])
    if team > 1 and userid in player:
        player[userid].spawn(team)

# ------------
# If the picked up item is not a Kevler-Vest (+ Helmet) then strip the player off his/her weapons
# ------------
def item_pickup(ev):
    if models() is not None and ev['es_userteam'] == '2' and ev['item'] not in ('vest', 'vesthelm'):
        player[ev['userid']].strip()

# ------------
# Delete the disconnecting player from the player-database and stop delayed messages or freezing
# ------------
def player_disconnect(ev):
    userid = ev['userid']
    gamethread.cancelDelayed('unfreeze_%s' % userid)
    gamethread.cancelDelayed('announce_%s' % userid)
    del player[userid]

# ------------
# If there is no config for the current map, announce that and tell that it's normal gameplay
# ------------
def round_start(ev):
    if models() is None:
        es.msg('#multi', '#green[#lightgreenSeekMe#green] #defaultMap #green%s #defaultis not available for SeekMe yet - Normal gameplay.' % es.getString('eventscripts_currentmap'))

""" Menu-Selection """
# ------------
# Change the player's model to the chosen one
# ------------
def menuSelect(userid, choice, popupid):
    player[str(userid)].changeModel(choice)

""" Say-Commands """
# ------------
# De/-activate Third-Person view
# ------------
def tp():
    player[str(es.getcmduserid())].perspective()

# ------------
# Check if the player already chose a model, if not, let him/her choose one
# ------------
def hide():
    player[str(es.getcmduserid())].hide()

""" EventScripts main-control functions """
# ------------
# Set the current version, register the say-commands "!hide" and "!tp", add every player on the server to the player-database
# ------------
def load():
    es.ServerVar('seekme_ver', '1.1').makepublic()
    if not es.exists('saycommand', '!hide'):
        es.regsaycmd('!hide', 'seekme/hide')
    if not es.exists('saycommand', '!tp'):
        es.regsaycmd('!tp', 'seekme/tp')
    for userid in es.getUseridList():
        userid = str(userid)
        player[userid] = Player(userid)

# ------------
# Delete the player-database, un-register the say-commands and stop delayed messages or freezing
# ------------
def unload():
    player.clear()
    if es.exists('saycommand', '!hide'):
        es.unregsaycmd('!hide')
    if es.exists('saycommand', '!tp'):
        es.unregsaycmd('!tp')
    for userid in es.getUseridList():
        gamethread.cancelDelayed('unfreeze_%s' % userid)
        gamethread.cancelDelayed('announce_%s' % userid)

""" End Code """
